import java.util.Scanner;


class Frazione {
	int num;
	int den;
}

class Exp {
	int codice; //0-->frazione
	            //1-->somma
				//2-->prodotto
				//3-->differenza
				//4-->divisione
	Frazione f; //usata solo se codice=0
	Exp e1;  //usate solo se codice>0
	Exp e2;
}


public class MainClass {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Exp e = leggiExp();
		
		stampaExp(e);
		System.out.print(" = ");
		Frazione f = evalExp(e);
		stampaFrazione (f);
		

	}
	
	static Exp creaExpFrazione (Frazione f){
		Exp e = new Exp();
		e.codice=0;
		e.f=f;
		return e;
	}
	
	static Exp creaExpSomma (Exp a, Exp b){
		Exp e = new Exp();
		e.codice=1;
		e.e1=a;
		e.e2=b;
		return e;
	}
	
	static Exp creaExpDifferenza (Exp a, Exp b){
		Exp e = new Exp();
		e.codice=3;
		e.e1=a;
		e.e2=b;
		return e;
	}
	
	static Exp creaExpProdotto (Exp a, Exp b){
		Exp e = new Exp();
		e.codice=2;
		e.e1=a;
		e.e2=b;
		return e;
	}
	
	static Exp creaExpDivisione (Exp a, Exp b){
		Exp e = new Exp();
		e.codice=4;
		e.e1=a;
		e.e2=b;
		return e;
	}
	
	
	static void stampaExp (Exp e){
		if (e==null) {
			System.out.print ("?");
			return; 
		}
		switch (e.codice){
		case 0:
			stampaFrazione(e.f);
			break;
		case 1:
			System.out.print ("(");
			stampaExp(e.e1);
			System.out.print ("+");
			stampaExp(e.e2);
			System.out.print (")");
			break;
		case 2:
			System.out.print ("(");
			stampaExp(e.e1);
			System.out.print ("*");
			stampaExp(e.e2);
			System.out.print (")");
			break;
		case 3:
			System.out.print ("(");
			stampaExp(e.e1);
			System.out.print ("-");
			stampaExp(e.e2);
			System.out.print (")");
			break;
		case 4:
			System.out.print ("(");
			stampaExp(e.e1);
			System.out.print ("/");
			stampaExp(e.e2);
			System.out.print (")");
			break;	
		}
		
	}
	
	static Exp leggiExp() {
		Exp e = leggiExpCrea(null);
		leggiExpRiempi(e, e);
		return e;
	}
	
	static Exp leggiExpCrea(Exp mainExp){
		Scanner s = new Scanner (System.in);
		System.out.print("Inserisci l'espressione "
				+ "corrispondente al primo ? in ");
		stampaExp(mainExp);
		System.out.println(":");
		System.out.println("0 - frazione");
		System.out.println("1 - somma");
		System.out.println("2 - prodotto");
		System.out.println("3 - differenza");
		System.out.println("4 - divisione");
		System.out.println("Inserisci la tua scelta: ");
		int scelta;
		do {
			scelta=s.nextInt();
			s.nextLine();
		} while (scelta<0 || scelta>4);
		switch (scelta){
		case 0:
			return creaExpFrazione(null);
		case 1:
			return creaExpSomma(null,null);
		case 2: 
			return creaExpProdotto(null,null);
		case 3:
			return creaExpDifferenza(null,null);
		case 4:
			return creaExpDivisione(null,null);
		}
		return null;		
	}
	
	static void leggiExpRiempi(Exp e, Exp mainExp){
		switch (e.codice){
		case 0:
			e.f=leggiFrazione();
			break;
		case 1:
		case 2:
		case 3:
		case 4:
			e.e1=leggiExpCrea(mainExp);
			leggiExpRiempi(e.e1,mainExp);
			e.e2=leggiExpCrea(mainExp);
			leggiExpRiempi(e.e2,mainExp);
		}
	}
	
	static Exp leggiExpFacile(){
		Scanner s = new Scanner (System.in);
		System.out.println();
		System.out.println("0 - frazione");
		System.out.println("1 - somma");
		System.out.println("2 - prodotto");
		System.out.println("3 - differenza");
		System.out.println("4 - divisione");
		System.out.println("Inserisci la tua scelta: ");
		int scelta;
		do {
			scelta=s.nextInt();
			s.nextLine();
		} while (scelta<0 || scelta>4);
		switch (scelta){
		case 0:
			Frazione f = leggiFrazione();
			return creaExpFrazione (f);
		case 1:
			System.out.println("Inserisci la prima sottoespressione");
			Exp e1 = leggiExpFacile();
			System.out.println("Inserisci la seconda sottoespressione");
			Exp e2 = leggiExpFacile();
			return creaExpSomma(e1,e2);
		case 2:
			System.out.println("Inserisci la prima sottoespressione");
			e1 = leggiExpFacile();
			System.out.println("Inserisci la seconda sottoespressione");
			e2 = leggiExpFacile();
			return creaExpProdotto(e1,e2);
		case 3:
			System.out.println("Inserisci la prima sottoespressione");
		    e1 = leggiExpFacile();
			System.out.println("Inserisci la seconda sottoespressione");
			e2 = leggiExpFacile();
			return creaExpDifferenza(e1,e2);
		case 4:
			System.out.println("Inserisci la prima sottoespressione");
		    e1 = leggiExpFacile();
			System.out.println("Inserisci la seconda sottoespressione");
			e2 = leggiExpFacile();
			return creaExpDivisione(e1,e2);
			
		}
		return null;
		
	}
	
	static boolean equivalenteExp(Exp e1, Exp e2){
		return equivalenteFrazione(evalExp(e1),
				                    evalExp(e2));
	}
	
	static Frazione evalExp (Exp e){
		if (e==null) return null;
		switch(e.codice){
		case 0:
			Frazione copia=copiaFrazione (e.f);
			riduciFrazione(copia);
			return copia;
		case 1:
			Frazione f1 = evalExp(e.e1);
			Frazione f2 = evalExp(e.e2);
			return sommaFrazione(f1,f2);
		case 2:
			f1 = evalExp(e.e1);
			f2 = evalExp(e.e2);
			return prodottoFrazione(f1,f2);	
		case 3:
			f1 = evalExp(e.e1);
			f2 = evalExp(e.e2);
			return differenzaFrazione(f1,f2);
		case 4:
			f1 = evalExp(e.e1);
			f2 = evalExp(e.e2);
			return divisioneFrazione(f1,f2);			
		}
		return null;
	}
	
	static Frazione creaFrazione (int n, int d){
		if (d==0) return null;
		Frazione f= new Frazione();
		f.num=n;
		f.den=d;
		return f;
	}
	
	static Frazione leggiFrazione (){
		Scanner s = new Scanner (System.in);
		System.out.println("Inserisci il numeratore: ");
		int n = s.nextInt();
		s.nextLine();
		System.out.println("Inserisci il denominatore: ");
		int d = s.nextInt();
		s.nextLine();
		return creaFrazione(n,d);
	}
	
	static void stampaFrazione (Frazione f){
		if (f==null) return;
		System.out.print(" ");
		boolean positiva= (f.num>=0 && f.den>0)
				          || (f.num<0 && f.den<0);
		if (!positiva) System.out.print ("(-");
		System.out.print (abs(f.num));
		if(abs(f.den)!=1) {
			System.out.print ("/"+abs(f.den));
		}
		if (!positiva) System.out.print (")");
		System.out.print(" ");
	}
	
	static int abs (int n){
		return (n>=0)?n:-n;
	}
	
	static boolean ugualeFrazione (Frazione f1,
			                         Frazione f2){
		if (f1==null || f2==null) return false;
		return (f1.num==f2.num) && (f1.den==f2.den);
	}
	
	static Frazione copiaFrazione(Frazione f1){
		if (f1==null) return null;
		return creaFrazione (f1.num, f1.den);
	}
	
	static void riduciFrazione(Frazione f){
		if (f==null) return;
		boolean positiva= (f.num>=0 && f.den>0)
		          || (f.num<0 && f.den<0);
		f.num=abs(f.num);
		f.den=abs(f.den);
		int MCD = MCD(f.num,f.den);
		
		f.num /=MCD;
		f.den /=MCD;
		
		if (!positiva) f.num *=-1;
		
	}

	static int MCD (int a, int b){
		int max=(a>=b)?a:b;
		int min=(a<=b)?a:b;
		while (min>0){
			int resto = max % min;
			max =min;
			min = resto;
		}
		return max;
	}
	
	static int mcm (int a, int b){
		return a/MCD(a,b)*b;
	}
	
	static Frazione sommaFrazione (Frazione f1,
									Frazione f2){
		if (f1==null || f2== null) return null;
		Frazione copia1 = copiaFrazione(f1);
		Frazione copia2 = copiaFrazione(f2);
		riduciFrazione(copia1);
		riduciFrazione(copia2);
		int mcmDen = mcm(copia1.den,copia2.den);
		int num=mcmDen/copia1.den*copia1.num  
			   +mcmDen/copia2.den*copia2.num;
		Frazione risultato=creaFrazione(num,mcmDen);
		riduciFrazione(risultato);
		return risultato;
	}
	
	static Frazione prodottoFrazione (Frazione f1,
								       Frazione f2){
		if (f1==null || f2== null) return null;
		Frazione copia1 = copiaFrazione(f1);
		Frazione copia2 = copiaFrazione(f2);
		riduciFrazione(copia1);
		riduciFrazione(copia2);
		int MCD1=MCD(copia1.num,copia2.den);
		copia1.num /= MCD1;
		copia2.den /= MCD1;
		int MCD2=MCD(copia2.num,copia1.den);
		copia2.num /= MCD2;
		copia1.den /= MCD2;
		Frazione risultato=creaFrazione(
			copia1.num*copia2.num,copia1.den*copia2.den);
		return risultato;			
	}
	
	static Frazione oppostaFrazione(Frazione f){
		if (f==null) return null;
		return creaFrazione(-f.num,f.den);
	}
	static Frazione differenzaFrazione (Frazione f1,
									     Frazione f2){
		if (f1==null || f2== null) return null;
		return sommaFrazione(f1,oppostaFrazione(f2));	
	}
	
	static Frazione inversaFrazione(Frazione f){
		if (f==null) return null;
		return creaFrazione(f.den,f.num);
	}
	
	static Frazione divisioneFrazione (Frazione f1,
		     						    Frazione f2){
		if (f1==null || f2== null) return null;
		return prodottoFrazione(f1,inversaFrazione(f2));	
	}
	
	static boolean equivalenteFrazione (Frazione f1,
										  Frazione f2){
		if (f1==null || f2== null) return false;
		Frazione copia1 = copiaFrazione(f1);
		Frazione copia2 = copiaFrazione(f2);
		riduciFrazione(copia1);
		riduciFrazione(copia2);
		return ugualeFrazione (copia1,copia2);		
	}
	
}
