class Elem {
	int valore;
	Elem next;
}

class Lista {
	Elem head;
	int size;
}


public class MainClass {

	static Lista creaLista (){
		return new Lista();
	}
	
	static Elem creaElem(int valore){
		Elem e = new Elem();
		e.valore=valore;
		return e;
	}
	
	static void aggiungiTesta (Lista l, int valore){
	    if (l==null) return;
	    Elem e = creaElem(valore);
	    e.next=l.head;
	    l.head=e;
	    l.size++;
	}
	
	static void aggiungiCoda (Lista l, int valore){
	    if (l==null) return;
	    if (l.size==0) {
	    	aggiungiTesta(l,valore);
	    } else {
	    Elem nuovo = creaElem(valore);
	    Elem e=l.head;
	    Elem prev=null;
	    while (e!=null){
	    	prev=e;
	    	e=e.next;
	    }
	    prev.next=nuovo;
	    l.size++;
	    }
	}
	
	static boolean presente (Lista l, Elem e){
		if (l==null || e==null) return false;
		Elem i =l.head;
		while (i!=null){
			if (e==i) return true;
			i=i.next;
		}
		return false;
	}
	
	static void aggiungiDopo (Lista l, Elem e, 
			                   int valore){
		if (l==null || e==null) return;
		if (presente (l,e)){
			Elem nuovo = creaElem(valore);
			nuovo.next=e.next;
			e.next=nuovo;
			l.size++;
		}
	}
	
	static void stampaLista (Lista l){
		if (l==null ) return;
		Elem e;
		int i;
		for (i=0,e=l.head;i<l.size;i++,e=e.next){
			System.out.print (e.valore);
			if (i<l.size-1) System.out.print("->");
		}
	}
	
	static Elem cerca (Lista l, int valore){
		if (l==null) return null;
		Elem e = l.head;
		while (e!=null){
			if (e.valore==valore) return e;
			e=e.next;
		}
		return null;
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		Lista l = creaLista();
		aggiungiTesta(l,4);
		aggiungiTesta(l,10);
		aggiungiCoda(l,8);
		
		Elem e = cerca(l,4);
		aggiungiDopo(l,e,20);
		
		stampaLista(l);
		
		
		
		
		
		
	}

}
